/* File Checker v.97 - By John Waters   */
/* Based on Test Archive by Greg Bastow */

if ~show(L,'rexxsupport.library') then
   call addlib('rexxsupport.library',0,-30,0)
if ~show('L','rexxarplib.library') then addlib('rexxarplib.library',0,-30,0)

parse arg uname','file .

options failat 21
options results
signal on BREAK_C
signal on FAILURE
signal on SYNTAX
Address Command

Alternate = 0                 /* Alternate file paths?   0=No   1=Yes         */
Validated = 0                 /* Validated Uploads=0  Non-Validated Uploads=1 */
Area      = 9999              /* Validation Area - Only used if Validated = 1 */
Sysop     = 'Sysop Name'   /* Sysop's name                               */
Forms     = 'DLGConfig:Text/' /* Directory you keep the message forms in.   */
Bad       = 'Bad.txt'         /* Names of the messages (forms) that get     */
Good      = 'Good.txt'        /* sent to you.                               */
Virus     = 'Virus.txt'

null      = '00'x
Private   = 'NO'

call makedir('t:'Uname'_FC')
call Pragma('Directory','t:'Uname'_FC')
filename = right(file,length(file)-lastpos('/',file))
name = translate(uname,' ','_')
comment = statef(file)
if (Validated) then area = word(comment,9)

if (Alternate) then do
   call open('input','file:area.bbs','R')
   do until area1 = area
      temp = readch('input',190)
      area1 = c2d(substr(temp,39,2))
      path1 = substr(temp,47,8)
      path = strip(path1,b,null)
      if eof('input') then leave
   end
   call close('input')
   filep = path||filename
end
else filep = 'file:'area'/'filename

if area = '-1' then do
   toname = word(comment,11)
   filep = 'user:'toname'/'filename
   private = toname
end


Say
Say 'Please wait while I strip any BBS adverts and check this archive.'
Say
Say 'Integrity'
/*call writech(STDOUT,'Integrity... ')*/


select
   when upper(right(filename,3)) == "LHA" then do 
	'DLGConfig:Utils/istrip 'file
        'LhA t 'file
	'Copy DLGConfig:Text/bbsad.displayme TO T:'
	'echo "       Time Uploaded => `date` <= " >T:bbsad.displayme'
	'lha -2a m 'file' T:bbsad.displayme >NIL:'
	'echo "'uname' uploaded 'file' on `date`." >>logs:upload.log'
	end
   when upper(right(filename,3)) == "LZH" then do
	'DLGConfig:Utils/istrip 'file
        'LhA t >NIL: 'file
	'Copy DLGConfig:Text/bbsad.displayme TO T:'
	'echo "       Time Uploaded => `date` <= " >T:bbsad.displayme'
	'lha -1a -Qh1024 m 'file' T:bbsad.displayme >NIL:'
	SAY '.LZH is nice, but have you thought about using .LHA? Alot faster!'
	'echo "'uname' uploaded 'file' on `date`." >>logs:upload.log'
	end
   when upper(right(filename,3)) == "ZOO" then do
        'Zoo -t 'file
	say 'Stripping any bbs adverts'
	'zoo -d 'file' #?.foo >NIL:'
	'zoo -d 'file' #?.displayme >NIL:'
	'zoo -d 'file' #?ad.txt >NIL:'
	'zoo -d 'file' #?add.txt >NIL:'
	'zoo -d 'file' #?.adv >NIL:'
	'zoo -d 'file' WhoMoved-It >NIL:'
	'Copy DLGConfig:Text/bbsad.displayme TO T:'
	'echo "       Time Uploaded => `date` <= " >T:bbsad.displayme'
	'zoo -a 'file' T:bbsad.displayme >NIL:'
	'Delete T:bbsad.displayme >NIL:'
	'echo "'uname' uploaded  'file' on `date`." >>logs:upload.log'
	end 
   when upper(right(filename,3)) == "ZIP" then do
        'unzip -t 'file
	Say 'Stripping any bbs adverts'
	'Copy DLGConfig:Text/bbsad.displayme TO T:'
	'echo "       Time Uploaded => `date` <= " >T:bbsad.displayme'
	'zip -k -9 -j 'file' T:767-2856.displayme >NIL:'
	'Delete T:767-2856.displayme >NIL:'
	'echo "'uname' uploaded  'file' on `date`." >>logs:upload.log'
	end
   when upper(right(filename,3)) == "ARC" then do
        'PKXArc -e >NIL: 'file
	'echo "'uname' uploaded  'file' on `date`." >>logs:upload.log'
	end
   when upper(right(filename,3)) == "ARJ" then do
        'Unarj >NIL: 'file
	'echo "'uname' uploaded  'file' on `date`." >>logs:upload.log'
	end
   when upper(right(filename,3)) == "DMS" then do
	'dmstestutrk >NIL: 'file
        'MAPUS.132 -krRtaAd 'file
	'echo "'uname' uploaded  'file' on `date`." >>logs:upload.log'
   end
   when upper(right(filename,3)) == "WRP" then do
	'warpadder >NIL: 'file
	'echo "'uname' uploaded  'file' on `date`." >>logs:upload.log'
   end
   when upper(right(filename,3)) == "OWS" then do
        'owscheck test 'file
	'echo "'uname' uploaded  'file' on `date`." >>logs:upload.log'
   end
   when upper(right(filename,3)) == "SHR" then do
        'shrink t 'file
	'Copy DLGConfig:Text/bbsad.displayme TO T:'
	'echo "       Time Uploaded => `date` <= " >T:bbsad.displayme'
	'shrink a 'file' T:bbsad.displayme >NIL:'
	'echo "'uname' uploaded  'file' on `date`." >>logs:upload.log'
   end

   otherwise do
        'c:Copy >NIL: 'file' t:'Uname'_FC'
   end
end

call pragma('directory','t:')

if RC > 0 then do
   'c:delete >NIL: t:'UName'_FC all'
   Say 
   Say 'Bad Archive.  Informing Sysop.'
   'c:copy 'forms||bad' t:bad.tmp'
   'c:echo "Uploaded By: 'name'" >>t:bad.tmp'
   'DLG:SendMSG -f "File Checker" -s 'filename' -b t:bad.tmp -q -r "'Sysop'"'
   'c:delete >NIL: t:bad.tmp'
   'c:echo "'filep'" >>ENV:'uname
   'c:echo "BAD" >>ENV:'uname
   'c:echo "'private'" >>ENV:'uname
   'c:echo "'area'" >>ENV:'uname
   exit
end

Say ' OK'

'c:list t:'UName'_FC '"lformat=%p%n"' all >t:arclist'
call writech(STDOUT,'Virus Check...')
call open('arclst','t:arclist','R')
n = 1
do while ~EOF('arclst')
   lfile = readln('arclst')
   address 'Virus_Checker' 'checkfile\'lfile
   if result = "RESULT" then iterate
   else do
      virus1 = result
      call close('arclst')
      'c:delete >NIL: t:'UName'_FC all'
      'c:delete >NIL: t:Arclist'
      Say ' Failed!'
      Say
      Say 'A 'virus1'.  Informing Sysop.'
      'c:copy 'forms||virus' t:virus.tmp'
      'c:echo "Uploaded By: 'name'" >>t:virus.tmp'
      'DLG:SendMSG -f "File Checker" -s "'filename','virus1'" -b t:virus.tmp -q -r "'Sysop'"'
/*above should be one line*/
      'c:delete >NIL: t:virus.tmp'
      'c:echo "'filep'" >>ENV:'uname
      'c:echo "'virus1'" >>ENV:'uname
      'c:echo "'private'" >>ENV:'uname
      'c:echo "'area'" >>ENV:'uname
      exit
   end
end
call close('arclst')

Say ' OK'

'c:echo "'filep'" >>ENV:'uname
'c:echo "NONE" >>ENV:'uname
'c:echo "'private'" >>ENV:'uname
'c:echo "'area'" >>ENV:'uname
'c:delete >NIL: t:'UName'_FC all'
'c:delete >NIL: t:Arclist'

Say
Say 'File checks out OK.'
/*'c:copy 'forms||good' t:good.tmp'
'c:echo "Uploaded By: 'name'" >>t:good.tmp'*/
'c:echo "This file, 'filename', has been uploaded by 'name', and was supplied with the following description :" >t:good.tmp'
'c:echo "has passed all the File Checker tests and needs to be validated." >>t:good.tmp'
'DLG:SendMSG -f "File Checker" -s 'filename' -b t:good.tmp -q -r "'Sysop'"'
'c:delete >NIL: t:good.tmp'
   'c:delete >NIL: t:'UName'_FC all'
exit


break_c:
failure:
SYNTAX:
  Say ''
  Say '*Hmmm, Looks like we got an Error in the File Checker.*'
  Say '*Please tell the Sysop.*'
  Say
 '*Line:' SIGL '   Error Code:' RC'*'
  exit
