/********************************************************************
 * Arexx script to perform some housekeeping tasks after an upload. *
 ********************************************************************/

if ~show('L','rexxarplib.library') then addlib('rexxarplib.library',0,-30,0)

/* we want to be passed the username, and the path/filename he uploaded */

parse arg UserName Filename

/* let's find out which node the user is on */

NumFiles = FileList("T:#?.user",Users,"F")

do i = 1 to NumFiles
   call open(fp,Users.i,"r")
   PortUser = readch(fp,36)
   if pos(upper(translate(UserName," ","_")),upper(PortUser)) ~= 0 then do
      PortName = substr(Users.i,3,3)
   end
   call close(fp)
end

/* change this to reflect the way you'd call dupcheck on your system */

address command 'DupCheck -a -n 'Filename

if RC == 5 then do

   DupArea = GetEnv("DUPAREA")
   DupName = GetEnv("DUPFILENAME")
   DupUser = GetEnv("DUPUPLOADER")

   Sysop = "Sysop_Name"

   call open(fp,"T:Dup."PortName,"W")

   call writeln(fp,'"'DupName'" was uploaded by "'DupUser'" and was found')
   call writeln(fp,'to have the following duplicate entries in the file catalog:')
   call writeln(fp,"")

   call close(fp)

   address command 'type >>T:Dup.'PortName' T:DupCheck.Tmp'

   address command 'Dlg:SendMsg -f "DupChecker v1.7" -s "Duplicate Upload" -b T:Dup.'PortName' -n -q -r 'Sysop

   address command 'echo >>T:'PortName'.body "--- DUPLICATE UPLOAD --- DO NOT DELETE THIS DESCRIPTION ---"'

   address command 'type >>T:'PortName'.body T:DupCheck.Tmp'

   address command 'echo >>T:'PortName'.body "---------------------------------------------------------------"'

   address command 'Delete >nil: t:DupCheck.Tmp'

   say "Duplicate files were detected.  The Sysop has been notified and will"
   say "verify whether or not the file is really a duplicate."
end

say ""

exit
